
%% multi-slot buffer + producer + consumer objects

:-object buffer_node.
	var data, next=null.

	set_node_data(Data) :-
		data := Data.
	set_node_next(Next) :-
		next := Next.

	get_node_data(Data) :-
		Data := data.
	get_node_next(Next) :-
		Next := next.

:-end_object buffer_node.


:-object(active_buffer).
	var head=null, tail=null, size=3, curr=0.

	active_buffer(N) :-
		main(N).

	get_item(Data) :-
		-- curr,
		head <- get_node_data(Data),
		head <- get_node_next(Next),
		head := Next,
		format('B ~w get ~w~n', [this, Data]),
		true.

	put_item(Data) :-
		Node := new(buffer_node),
		Node <- set_node_data(Data),
		( curr =:= 0 ->
			head := Node,
			tail := Node
		;
			tail <- set_node_next(Node),
			tail := Node
		),
/***
		( curr =:= 0 ->
			put_init(Node)
		;
			put_next(Node)
		),
***/
		format('B ~w put ~w~n', [this, Data]),
		++ curr,
		true.

	put_init(Node) :-
		head := Node,
		tail := Node.
	put_next(Node) :-
		tail <- set_node_next(Node),
		tail := Node.

	out_list(Node) :-
		format('~tcurrent nodes:~n'),
		out_list(0, Node).

	out_list(curr, _) :-
		format('~tend node list.~n').
	out_list(I, Node) :-
		N is I + 1,
		Node <- get_node_data(Data),
		Node <- get_node_next(Link),
		format('~tnode no. ~w, data = ~w~n', [N, Data]),
		out_list(N, Link).

	loop(0) :-
		format('B ~w end of loop ...~n', [this]).
	loop(I) :-
		accept(
			put_item(P) <== [curr < size],
			get_item(G) <== [curr > 0]
		),
		out_list(head),
		N is I-1,
		loop(N).

	main(I) :-
		format('B ~w active_buffer main/1 running~n', [this]),
		loop(I).

:-end_object(active_buffer).


:-object(consumer_data).

	consumer_data(N,B) :-
		main(N,B).

	loop(0,_) :-
		format('C ~w end of loop ...~n', [this]).
	loop(I,B) :-
		This = this,
		B<-get_item(X),
		format('C ~w rcv ~w~n', [This, X]),
		N is I-1,
		loop(N,B).

	main(I,B) :-
		This = this,
		format('C ~w consumer_data main/2 running~n', [This]),
		loop(I,B).

:-end_object(consumer_data).


:-object(producer_data).

	producer_data(N,B) :-
		main(N,B).

	loop(0,_) :-
		format('P ~w end of loop ...~n', [this]).
	loop(I,B) :-
		This = this,
		format('P ~w snd ~w~n', [This, I]),
		B<-put_item(I),
		N is I-1,
		loop(N,B).

	main(I,B) :-
		This = this,
		format('P ~w producer_data main/2 running~n', [This]),
		loop(I,B).

:-end_object(producer_data).


:-object pxbuff.

main :-
	B := new(active_buffer(10)),
	C := new(consumer_data(5,B)),
	P := new(producer_data(5,B)),
	format('~nBuff = ~w, Cons = ~w, Prod = ~w~n', [B,C,P]),
	true.

:-end_object pxbuff.

